package com.ruoyi.mp.service;

import com.ruoyi.RuoYiApplication;
import com.ruoyi.mp.constant.OrderStatus;
import com.ruoyi.mp.domain.UserOrder;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;

/**
 * mybatis-plus
 * 乐观锁
 * 自动注入创建时间，操作者
 * 主键数据库自增
 */
@SpringBootTest(classes = RuoYiApplication.class)
class UserOrderServiceTest {

    @Resource
    UserOrderService userOrderService;

    /***
     * 创建表数据
     */
    @Test
    void add() {
        userOrderService.add();
        //15:49:29.640 [main] DEBUG c.r.m.m.U.insert - [debug,135] - ==>  Preparing: INSERT INTO user_order ( uid, gid, order_time, amount, pay_type, goods_name, status, version, create_by, create_time, update_by, update_time ) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? )
        //15:49:29.789 [main] DEBUG c.r.m.m.U.insert - [debug,135] - ==> Parameters: 123(Long), 4885(Long), 2024-01-19 15:49:29.628(Timestamp), 15200(Long), W(String), 测试商品(String), 0(Integer), 0(Long), test(String), 2024-01-19 15:49:29.638(Timestamp), test(String), 2024-01-19 15:49:29.639(Timestamp)
        //15:49:29.932 [main] DEBUG c.r.m.m.U.insert - [debug,135] - <==    Updates: 1
        //添加成功
        //UserOrder{orderId=4, uid=123, gid=4885, orderTime=Fri Jan 19 15:49:29 CST 2024, amount=15200, payType='W', goodsName='测试商品', status=NORMAL, version=0, create_by=test, create_time=Fri Jan 19 15:49:29 CST 2024, update_by=test, update_time=Fri Jan 19 15:49:29 CST 2024}
    }

    /**
     * 更新操作
     */
    @Test
    void update() {
        UserOrder userOrder = userOrderService.get(4);
        System.out.println("更新前:" + userOrder);
        userOrder.setStatus(OrderStatus.PAYED);
        userOrderService.update(userOrder);
        userOrder = userOrderService.get(4);
        System.out.println("更新后:" + userOrder);
        //15:50:42.433 [main] DEBUG c.r.m.m.U.selectById - [debug,135] - ==>  Preparing: SELECT order_id,uid,gid,order_time,amount,pay_type,goods_name,status,version,create_by,create_time,update_by,update_time FROM user_order WHERE order_id=?
        //15:50:42.436 [main] DEBUG c.r.m.m.U.selectById - [debug,135] - ==> Parameters: 4(Long)
        //15:50:42.449 [main] DEBUG c.r.m.m.U.selectById - [debug,135] - <==      Total: 1
        //更新前:UserOrder{orderId=4, uid=123, gid=4885, orderTime=Fri Jan 19 15:49:30 CST 2024, amount=15200, payType='W', goodsName='测试商品', status=NORMAL, version=0, create_by=test, create_time=Fri Jan 19 15:49:30 CST 2024, update_by=test, update_time=Fri Jan 19 15:49:30 CST 2024}
        //15:50:42.463 [main] DEBUG c.r.m.m.U.updateById - [debug,135] - ==>  Preparing: UPDATE user_order SET uid=?, gid=?, order_time=?, amount=?, pay_type=?, goods_name=?, status=?, version=?, create_by=?, create_time=?, update_by=?, update_time=? WHERE order_id=? AND version=?
        //15:50:42.473 [main] DEBUG c.r.m.m.U.updateById - [debug,135] - ==> Parameters: 123(Long), 4885(Long), 2024-01-19 15:49:30.0(Timestamp), 15200(Long), W(String), 测试商品(String), 1(Integer), 1(Long), test(String), 2024-01-19 15:49:30.0(Timestamp), test(String), 2024-01-19 15:49:30.0(Timestamp), 4(Long), 0(Long)
        //15:50:42.675 [main] DEBUG c.r.m.m.U.updateById - [debug,135] - <==    Updates: 1
        //更新成功
        //15:50:42.676 [main] DEBUG c.r.m.m.U.selectById - [debug,135] - ==>  Preparing: SELECT order_id,uid,gid,order_time,amount,pay_type,goods_name,status,version,create_by,create_time,update_by,update_time FROM user_order WHERE order_id=?
        //15:50:42.677 [main] DEBUG c.r.m.m.U.selectById - [debug,135] - ==> Parameters: 4(Long)
        //15:50:42.682 [main] DEBUG c.r.m.m.U.selectById - [debug,135] - <==      Total: 1
        //更新后:UserOrder{orderId=4, uid=123, gid=4885, orderTime=Fri Jan 19 15:49:30 CST 2024, amount=15200, payType='W', goodsName='测试商品', status=PAYED, version=1, create_by=test, create_time=Fri Jan 19 15:49:30 CST 2024, update_by=test, update_time=Fri Jan 19 15:49:30 CST 2024}

    }
}