package com.ruoyi.web.core.config;

import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import org.apache.ibatis.reflection.MetaObject;

import java.util.Date;

/**
 * 注入公共字段自动填充,任选注入方式即可
 * <h2>
 * 继承使用
 * </h2>
 * <p>
 * 继承后<i>重写 {@link #getOperator()}</i> 和 <i>重新注入 Bean</i>
 * </p>
 * <pre>
 *     @author yexuejc
 * @Bean
 *     public MyMetaObjectHandler metaObjectHandler() {
 *         return new MyMetaObjectHandler();
 *     }
 * </pre>
 */
public class MplusMetaObjectHandler implements MetaObjectHandler {

    /**
     * 创建时间
     */
    protected String crtTimeColumn = "createTime";
    /**
     * 创建人
     */
    protected String crtByColumn = "createBy";
    /**
     * 最后操作时间
     */
    protected String updateTimeColumn = "updateTime";
    /**
     * 最后操作人
     */
    protected String updateByColumn = "updateBy";

    /**
     * 设置操作者
     * <p>
     * 应设置登录账号为操作者，这里由每个工程具体实现
     * </p>
     * <p>
     * 返回null时，会查找consumerId作为操作者，找不到会设置默认值
     * <br/>
     * 返回"" 时，会存""
     * </p>
     *
     * @return
     */
    protected String getOperator() {
        return "";
    }

    @Override
    public void insertFill(MetaObject metaObject) {
        Object crtTime = metaObject.getValue(crtTimeColumn);
        if (crtTime == null) {
            this.strictInsertFill(metaObject, crtTimeColumn, Date.class, new Date());
        }

        Object crtBy = metaObject.getValue(crtByColumn);
        if (crtBy == null) {
            this.strictInsertFill(metaObject, crtByColumn, String.class, getOperator());
        }

        Object mdfyTime = metaObject.getValue(updateTimeColumn);
        if (mdfyTime == null) {
            this.strictInsertFill(metaObject, updateTimeColumn, Date.class, new Date());
        }

        Object mdfyBy = metaObject.getValue(updateByColumn);
        if (mdfyBy == null) {
            this.strictInsertFill(metaObject, updateByColumn, String.class, getOperator());
        }

    }

    @Override
    public void updateFill(MetaObject metaObject) {
        Object mdfyTime = metaObject.getValue(updateTimeColumn);
        if (mdfyTime == null) {
            this.strictInsertFill(metaObject, updateTimeColumn, Date.class, new Date());
        }

        Object mdfyBy = metaObject.getValue(updateByColumn);
        if (mdfyBy == null) {
            this.strictInsertFill(metaObject, updateByColumn, String.class, getOperator());
        }
    }
}
